package rpgEngine.Resources;

import java.awt.image.BufferedImage;
import java.io.BufferedReader;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.Dictionary;
import java.util.Hashtable;
import javax.imageio.ImageIO;

import rpgEngine.Data.Raw.Graphics.CharacterSet;
import rpgEngine.Util.ImageManip;


public class CharacterSetPool {
	private static CharacterSetPool instance;
	private Dictionary<Integer,CharacterSet> items;
	
	private CharacterSetPool() {
		items = new Hashtable<Integer,CharacterSet>();
		loadData();
	}
	
	
	public static CharacterSetPool getInstance() {
		if(instance == null) {
			instance = new CharacterSetPool();
		}
		
		return instance;
	}
	
	
	public CharacterSet getPoolItem(Integer i) {
		CharacterSet item = null;
		
		try 
		{
			item = items.get(i);	
		}
		catch(Exception e) 
		{
			return null;	
		}
		
		return item;
	}
	
	
	private void loadData() {
		String filename = "charactersets.cfg";
		String[] columns = null;
		InputStream fileStream = null;
		InputStream imageStream = null;
		BufferedReader reader = null;
		String line = "";
		BufferedImage baseImg = null;
		BufferedImage img = null;
		CharacterSet charSet = null;
		
		//Open File
		try {
			fileStream = this.getClass().getResourceAsStream("Config/" + filename);
			reader = new BufferedReader(new InputStreamReader(fileStream));
		}
		catch(Exception e) {
			System.err.println("Error openning file" + filename);
			System.err.println(e.toString());
			return;
		}
		
		//Read File
		try {
			while(reader.ready()) {
				line = reader.readLine();
				
				columns = line.split(",");
				
				if(columns[0].equals("ID") == false) {
					imageStream = this.getClass().getResourceAsStream("Image/" + columns[2]);
					baseImg = ImageIO.read(imageStream);
					
					img = baseImg.getSubimage(Integer.parseInt(columns[3]), 
											  Integer.parseInt(columns[4]), 
											  72, 128);
					
					if(columns[7].equals("-1") == false) {
						img = ImageManip.makeColorTransparent(img,Integer.parseInt(columns[5]),
													   Integer.parseInt(columns[6]),
													   Integer.parseInt(columns[7]));
					}
					
					charSet = new CharacterSet(columns[1],img);
					
					items.put(Integer.parseInt(columns[0]),charSet);
				}
			}
		}
		catch(Exception e) {
			System.err.println("Error reading file" + filename);
			System.err.println(e.toString());
			return;
		}
		
		//Close File
		try {
			reader.close();
			fileStream.close();
		}
		catch(Exception e) {
			System.err.println("Error closing file" + filename);
			System.err.println(e.toString());
			return;
		}
	}
}
